Redmine - Feature #33945

Allow normal users to delete projects with permission
2020-09-01 17:10 - Holger Just

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Go MAEDA % Done: 0%
Category: Permissions and roles Estimated time: 0.00 hour
Target version: 4.2.0

Resolution: Fixed

Description

In self-managed environments where users can create and manage projects on their own without Administrator involvement, it might
be helpful to allow users to delete their own projects when they are not needed anymore. Using the existing permissions system, this
can be easily managed.

The attached patch implements this against the current trunk (r19997). We allow to delete a project if the user has the necessary
permission in the project AND if the project is a leaf-project without further subprojects.

The latter restriction is intended as a fail-safe to prevent users from deleting large project trees. We could theoretically allow the
deletion of whole trees if the user has the permission to delete all projects in the tree. However, this check would likely be prone to
races and helps only for uncommon cases. Also, Administrators can delete full project trees as before.

The necessary permission is not granted to any role by default so that an Administrator has to consciously grant this permission if
required.

Related issues:
Has duplicate Redmine - Feature #15423: Permission to delete own project Closed
Has duplicate Redmine - Patch #15616: Add a permission setting allowing membe... Closed

Associated revisions

Revision 20034 - 2020-09-15 06:15 - Go MAEDA

Allow normal users to delete a project (#33945).

Patch by Holger Just.

Revision 20035 - 2020-09-15 06:19 - Go MAEDA
Update locales (#33945).

History

#1 - 2020-09-01 23:35 - Go MAEDA

- Has duplicate Feature #15423: Permission to delete own project added

#2 - 2020-09-01 23:41 - Go MAEDA

- Target version set to Candidate for next major release

#3 - 2020-09-11 09:57 - Go MAEDA

- Target version changed from Candidate for next major release to 4.2.0

Setting the target version to 4.2.0.

#4 - 2020-09-15 06:16 - Go MAEDA
- Status changed from New to Closed

- Assignee set to Go MAEDA

Committed the patch.

Thank you for improving Redmine.
#5 - 2020-11-16 09:20 - Go MAEDA

- Category changed from Projects to Permissions and roles

#6 - 2020-11-28 09:58 - Go MAEDA

- Has duplicate Patch #15616: Add a permission setting allowing members to delete their own projects added

#7 - 2021-03-28 01:05 - Go MAEDA
- Tracker changed from Patch to Feature

- Resolution set to Fixed

Files

0001-Allow-normal-users-to-delete-a-project.patch 7.72 KB 2020-09-01 Holger Just
